;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~        (C) Copyright raphi Software 2004 - All Rights Reserved      ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~ Author : Raphal PASQUIER                                           ~
;~ Email  : raphael.pasquier@neuf.fr                                   ~
;~ Version: 0.0.0.2                                                    ~
;~ Date   : 20/08/2005                                                 ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~                                                                     ~
;~    exemple d' utilisation de yasm et du C avec gcc sur GNU/linux    ~
;~                                                                     ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~                                                                     ~
;~  yasm -m amd64 -f elf software.asm -o software.o                    ~
;~                                                                     ~
;~  gcc -m64 software.o main.c -o main                                 ~
;~                                                                     ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~                                                                     ~
;~ Description : fait la somme de deux entiers longs positifs          ~
;~                                                                     ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

BITS 64
	
GLOBAL add_R_2P_x86_64_bini_spe

; en C => unsigned long int add_R_2P_x86_64_bini( Lii* a , Lii* b )
; a <- a + b
; I suppose that a > b >= 0 .
; return the overflow digit !!!
;
; 
; registres utiliss :
; rax
; rcx
; rdx
; rsi
; rdi
; r8
; r9 


add_R_2P_x86_64_bini_spe:

	mov rcx, [rsi]  ; rcx = signe de b
	test rcx, rcx
	jnz l1
	ret 

l1:
	xor r8,r8        ; carry = 0
	mov rcx, [rsi+32] ; rcx = b.indiceMax
	mov r10, rcx
	mov rdx, [rdi+16] ; rdi = &mantisse de a
	mov rsi, [rsi+16] ; rsi = &mantisse de b
	
boucle:
	xor rax, rax
	mov r9, [rdx]
	add r9, [rsi]
	adc rax, 0   ; rcupre la retenue dans rax
	add r9, r8
	adc rax, 0   ; rcupre la retenue dans rax
	mov [rdx], r9
	mov r8, rax
	add rsi,8
	add rdx,8
	dec rcx
	js l2  
	jmp boucle

l2:
	test rax, rax  ; rax = r8 = carry  
	jnz l3
	ret

l3:
	mov rcx, [rdi+32] ; rcx = a.indiceMax
	sub rcx, r10      ; rcx = a.indiceMax - b.indiceMax
	
boucle2:
	dec rcx
	js l4
	xor rax, rax
	add [rdx], r8
	adc rax, 0
	mov r8, rax
	test r8, r8
	jz l4
	add rdx, 8
	jmp boucle2

l4:
	mov rcx, [rdi+32] ; rcx = a.indiceMax
	mov rsi, [rdi+8]  ; rsi = a.tailleMantisse
	dec rsi
	cmp rcx,rsi
	jz l5
	test rax, rax
	jz l5
	inc rcx
	mov [rdi+32], rcx
	mov [rdx], rax
	xor rax, rax

l5:
	ret



