/*
 * Routines conues par Raphal Pasquier
*/
/*
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/times.h>
#include <math.h>

#include "lfx86_64.h"

#define PARITE 1L



long int arctan_bini( Lii* a,long int divisor,long int nb_decimales_en_base_BASE64_BINI )
// Cette routine calcule arctan( 1 / divisor ) et met le rsultat dans a.
{
 Lii b ;
 Lii un ;
 unsigned long int d,n ;

 createLii( a,nb_decimales_en_base_BASE64_BINI ) ;
 if (( a->mantisse == NULL ) )
	{
	 printf("not enough memeory !!!\n") ;
	 return 1 ;
	}

 createLii( &b,nb_decimales_en_base_BASE64_BINI ) ;
 if (( b.mantisse == NULL ) )
	{
	 printf("not enough memeory !!!\n") ;
	 destroyLii( a ) ;
	 return 1 ;
	}

 createLii( &un,nb_decimales_en_base_BASE64_BINI ) ;
 if (( un.mantisse == NULL ) )
	{
	 printf("not enough memeory !!!\n") ;
	 destroyLii( a ) ;
	 destroyLii( &b ) ;
	 return 1 ;
	}

 initialise_fixedPoint_bini( a , 1 ) ;
 divHalfB_R_x86_64_bini( a , divisor ) ;
 d =  divisor *  divisor ;
 copyLii( &un , a ) ;
 divHalfB_R_x86_64_bini( &un , d ) ;

 for( n = 1 ; ; n++ )
 	{
	 divHalfB_x86_64_bini( &b , &un , 2*n+1 ) ;
	 if ( ( n & PARITE ) == 1 )  sub_R_2P_x86_64_bini_spe( a , &b ) ;
	 	else add_R_2P_x86_64_bini_spe( a , &b ) ;
	 divHalfB_R_x86_64_bini( &un , d ) ;
	 if ( un.signe == 0 ) break ;
	}

 destroyLii( &un ) ;
 destroyLii( &b ) ;
 return 0  ;
}


long int pi_Newton_bini( Lii* p,long nb_decimales_en_base_BASE64_BIN )
{
 Lii arctan_3 ;
 clock_t    tops , tops2 , tops3 ;
 int err ;


 printf("\n Formula used (de Newton) :\n") ;
 printf(" pi/4 = arctan( 1/2 ) + arctan( 1/3 )\n\n") ;
 tops = times(NULL) ;
 err = arctan_bini( p,2,nb_decimales_en_base_BASE64_BIN  ) ;// p = arctan(1/5)
 if ( err > 0 ) return 1 ;
 tops2 = times(NULL) ;
 printf(" Duration = %7.3f seconds for arctan(1/2).\n" , (tops2-tops)/ 100.0 ) ;
 mulB_R_x86_64_bini( p,4 ) ;
 tops2 = times(NULL) ;
 err = arctan_bini( &arctan_3,3,nb_decimales_en_base_BASE64_BIN  ) ;
 if ( err > 0 )
	{
	 destroyLii( p ) ;
	 return 1 ;
	}
 tops3 = times(NULL) ;
 printf(" Duration = %7.3f seconds for arctan(1/3).\n" , (tops3-tops2)/ 100.0 ) ;
 mulB_R_x86_64_bini( &arctan_3 , 4 ) ;
 add_R_2P_x86_64_bini_spe( p,&arctan_3 ) ;

 printf(" Total duration = %7.3f secondes.\n" , (tops3-tops)/ 100.0 ) ;
 destroyLii( &arctan_3 ) ;

 return 0 ;
}



int pi_Machin_bini( Lii* p,long nb_decimales_en_base_BASE64_BIN )
{
 Lii arctan_239 ;
 clock_t    tops , tops2 , tops3 ;
 int err ;


 printf("\n Formula used (de Machin) :\n") ;
 printf(" pi/4 = 4 arctan( 1/5 ) - arctan( 1/239 )\n\n") ;
 tops = times(NULL) ;
 err = arctan_bini( p,5,nb_decimales_en_base_BASE64_BIN  ) ;// p = arctan(1/5)
 if ( err > 0 ) return 1 ;
 tops2 = times(NULL) ;
 printf(" Duration = %7.3f seconds for arctan(1/5).\n" , (tops2-tops)/ 100.0 ) ;
 mulB_R_x86_64_bini( p,16 ) ;
 tops2 = times(NULL) ;
 err = arctan_bini( &arctan_239,239,nb_decimales_en_base_BASE64_BIN  ) ;
 if ( err > 0 )
	{
	 destroyLii( p ) ;
	 return 1 ;
	}
 tops3 = times(NULL) ;
 printf(" Duration = %7.3f seconds for arctan(1/239).\n" , (tops3-tops2)/ 100.0 ) ;
 mulB_R_x86_64_bini( &arctan_239 , 4 ) ;
 sub_R_2P_x86_64_bini_spe( p,&arctan_239 ) ;

 printf(" Duration = %7.3f seconds.\n" , (tops3-tops)/ 100.0 ) ;
 destroyLii( &arctan_239 ) ;

 return 0 ;
}



int pi_arctan_18_57_239_bini( Lii* p,long nb_decimales_en_base_BASE64_BIN )
{
 Lii b ;
 clock_t    tops , tops2 , tops3 ;
 int err ;


 printf("\n Formula used :\n") ;
 printf(" pi/4 = 12 arctan(1/18) + 8 arctan( 1/57 ) + 5 arctan( 1/239 )\n\n") ;
 tops = times(NULL) ;
 err = arctan_bini( p,18,nb_decimales_en_base_BASE64_BIN  ) ;
 if ( err > 0 ) return 1 ;
 tops2 = times(NULL) ;
 printf(" Duration = %7.3f seconds for arctan(1/18).\n" , (tops2-tops)/ 100.0 ) ;
 mulB_R_x86_64_bini( p , 48 ) ;
 tops2 = times(NULL) ;
 err = arctan_bini( &b,57,nb_decimales_en_base_BASE64_BIN  ) ;
 if ( err > 0 )
	{
	 destroyLii( p ) ;
	 return 1 ;
	}
 tops3 = times(NULL) ;
 printf(" Duration = %7.3f seconds for arctan(1/57).\n" , (tops3-tops2)/ 100.0 ) ;
 mulB_R_x86_64_bini( &b , 32 ) ;
 add_R_2P_x86_64_bini_spe( p,&b ) ;
 destroyLii( &b ) ;
 tops2 = times(NULL) ;
 err = arctan_bini( &b,239,nb_decimales_en_base_BASE64_BIN  ) ;
 if ( err > 0 )
	{
	 destroyLii( p ) ;
	 return 1 ;
	}
 tops3 = times(NULL) ;
 printf(" Duration = %7.3f seconds for arctan(1/239).\n" , (tops3-tops2)/ 100.0 ) ;
 mulB_R_x86_64_bini( &b , 20 ) ;
 sub_R_2P_x86_64_bini_spe( p,&b ) ;
 printf(" Duration = %7.3f seconds.\n" , (tops3-tops)/ 100.0 ) ;
 destroyLii( &b ) ;
 return 0 ;
}



int pi_arctan_23_182_5118_6072_bini( Lii* p,long nb_decimales_en_base_BASE64_BIN )
// pi/4 = 17 arctan(1/23) + 8 arctan( 1/182 ) + 10 arctan( 1/5118 ) + 5 arctan( 1/6072 )
{
 Lii b ;
 clock_t    tops , tops2 , tops3 ;
 int err ;

 printf(" Formula used :\n") ;
 printf(" pi/4 = 17 arctan(1/23) + 8 arctan( 1/182 ) + 10 arctan( 1/5118 ) + 5 arctan( 1/6072 )\n\n") ;
 tops = times(NULL) ;
 err = arctan_bini( p,23,nb_decimales_en_base_BASE64_BIN ) ;
 if ( err > 0 ) return 1 ;
 tops2 = times(NULL) ;
 printf(" Duration = %7.3f seconds for arctan(1/23).\n" , (tops2-tops)/ 100.0 ) ;
 mulB_R_x86_64_bini( p,68 ) ;
 tops2 = times(NULL) ;
 err = arctan_bini( &b,182,nb_decimales_en_base_BASE64_BIN ) ;
 if ( err > 0 )
	{
	 destroyLii( p ) ;
	 return 1 ;
	}
 tops3 = times(NULL) ;
 printf(" Duration = %7.3f seconds for arctan(1/182).\n" , (tops3-tops2)/ 100.0 ) ;
 mulB_R_x86_64_bini( &b,32 ) ;
 add_R_2P_x86_64_bini_spe( p,&b ) ;
 destroyLii( &b ) ;
 tops2 = times(NULL) ;
 err = arctan_bini( &b,5118,nb_decimales_en_base_BASE64_BIN  ) ;
 if ( err > 0 )
	{
	 destroyLii( p ) ;
	 return 1 ;
	}
 tops3 = times(NULL) ;
 printf(" Duration = %7.3f seconds for arctan(1/5118).\n" , (tops3-tops2)/ 100.0 ) ;
 mulB_R_x86_64_bini( &b,40 ) ;
 add_R_2P_x86_64_bini_spe( p,&b ) ;
 destroyLii( &b ) ;
 tops2 = times(NULL) ;
 err = arctan_bini( &b,6072,nb_decimales_en_base_BASE64_BIN ) ;
 if ( err > 0 )
	{
	 destroyLii( p ) ;
	 return 1 ;
	}
 tops3 = times(NULL) ;
 printf(" Duration = %7.3f seconds for arctan(1/6072).\n" , (tops3-tops2)/ 100.0 ) ;
 printf(" Total duration = %7.3f seconds.\n" , (tops3-tops)/ 100.0 ) ;
 mulB_R_x86_64_bini( &b,20 ) ;
 add_R_2P_x86_64_bini_spe( p,&b ) ;
 destroyLii( &b ) ;
 return 0 ;
}



int calcul_pi( long base, long Nb_decimales,int formule )
// formule = 1   ::  pi/4 = arctan(1/2) + arctan(1/3)	(Newton)
// formule = 2   ::  pi/4 = 4 arctan(1/5) - arctan(1/239)   (Machin)
// formule = 3   ::  pi/4 = 12 arctan(1/18) + 8 arctan( 1/57 ) + 5 arctan( 1/239 )
// formule = 4   ::  pi/4 = 17 arctan(1/23) + 8 arctan( 1/182 ) + 10 arctan( 1/5118 ) + 5 arctan( 1/6072 )
{
 Lii pi ;
 long int Nb_decimales_Base64 ;
 long int error ;

 switch(base)
	{
	 case 16 : Nb_decimales_Base64 = ( Nb_decimales / 16 ) + 4 ;  break ;
	 case 2  : Nb_decimales_Base64 = ( Nb_decimales / 64 ) + 4 ; break ;
	 default : return 1 ;
	}

 if (( base == 2 ) || ( base == 16 ))
	{
	 switch(formule)
		{
		 case 1 : error = pi_Newton_bini( &pi,Nb_decimales_Base64 ) ; break ;
		 case 2 : error = pi_Machin_bini( &pi,Nb_decimales_Base64 ) ; break ;
		 case 3 : error = pi_arctan_18_57_239_bini( &pi,Nb_decimales_Base64 ) ; break ;
		 case 4 : error = pi_arctan_23_182_5118_6072_bini( &pi,Nb_decimales_Base64 ) ; break ;
		 default : return 1 ;
		}
	  if ( error > 0 )
		{
		 printf("Not enough memory !\n\n") ;
		 return 1 ;
		}
		else
		{
		 if ( base == 2 )  print_cst_base2_bini( &pi ) ;
		 	      else print_cst_base16_bini( &pi ) ;
		}
	 destroyLii( &pi ) ;
	 return 0 ;
	}

 return 1 ;
}



int calcul_sqrt2( long base, long Nb_decimales )
{
 long int k ;
 Lii un ;
 Lii sqrt2 ;
 Lii aux ;
 long int Nb_decimales_Base64 ;
 clock_t    tops , tops2 ;

 switch(base)
	{
	 case 16 : Nb_decimales_Base64 = ( Nb_decimales / 16 ) + 4 ;  break ;
	 case 2  : Nb_decimales_Base64 = ( Nb_decimales / 64 ) + 3 ; break ;
	 default : return 1 ;
	}

 // Cration des trois nombres.
 createLii( &sqrt2 , Nb_decimales_Base64 ) ;
 if ( sqrt2.mantisse == NULL )
	{
	 printf(" not enough memeory !!!\n") ;
	 return 1 ;
	}
 createLii( &un    , Nb_decimales_Base64 ) ;
 if ( un.mantisse == NULL )
	{
	 printf(" not enough memeory !!!\n") ;
	 destroyLii( &sqrt2 ) ;
	 return 1 ;
	}
 createLii( &aux   , Nb_decimales_Base64 ) ;
 if ( aux.mantisse == NULL )
	{
	 printf(" not enough memeory !!!\n") ;
	 destroyLii( &sqrt2 ) ;
	 destroyLii( &un ) ;
	 return 1 ;
	}

 printf("\n Formula used :\n") ;
 printf(" sqrt(2) = 27720/19601/sqrt(1-1/384199201) \n\n") ;


 if (( base == 2 ) || ( base == 16 ))
	{
	 initialise_fixedPoint_bini( &sqrt2, 1 ) ;
	 initialise_fixedPoint_bini( &un, 1 ) ;
	 tops = times(NULL) ;

	 for ( k = 0 ; ; k++ )
		{
		 divHalfB_R_x86_64_bini( &un , 384199201 ) ;
		 if ( un.signe == 0 ) break ;
		 divHalfB_x86_64_bini( &aux , &un , 2*k+ 2 ) ;
		 sub_R_2P_x86_64_bini_spe( &un , &aux ) ;
		 add_R_2P_x86_64_bini_spe( &sqrt2 , &un ) ;
		}

	 tops2 = times(NULL) ;
	 printf(" Duration = %7.3f seconds.\n" , (tops2-tops)/ 100.0 ) ;
	 printf(" Number of iterations = %ld\n\n" , k ) ;

	 mulB_R_x86_64_bini( &sqrt2 , 27720 ) ;
	 divHalfB_R_x86_64_bini( &sqrt2 , 19601 ) ;
	 if ( base == 2 )  print_cst_base2_bini( &sqrt2 ) ;
		      else print_cst_base16_bini( &sqrt2 ) ;
	}

 destroyLii( &sqrt2 ) ;
 destroyLii( &un ) ;
 destroyLii( &aux ) ;
 return 0 ;
}



int calcul_inv_sqrt2( long base, long Nb_decimales )
{
 long k ;
 Lii un ;
 Lii sqrt2 ;
 Lii aux ;
 long Nb_decimales_Base64 ;
 clock_t    tops , tops2 ;

 switch(base)
	{
	 case 16 : Nb_decimales_Base64 = ( Nb_decimales / 16 ) + 4 ;  break ;
	 case 2  : Nb_decimales_Base64 = ( Nb_decimales / 64 ) + 3 ; break ;
	 default : return 1 ;
	}

 // Cration des trois nombres.
 createLii( &sqrt2 , Nb_decimales_Base64 ) ;
 if ( sqrt2.mantisse == NULL )
	{
	 printf(" not enough memeory !!!\n") ;
	 return 1 ;
	}
 createLii( &un    , Nb_decimales_Base64 ) ;
 if ( un.mantisse == NULL )
	{
	 printf(" not enough memeory !!!\n") ;
	 destroyLii( &sqrt2 ) ;
	 return 1 ;
	}
 createLii( &aux   , Nb_decimales_Base64 ) ;
 if ( aux.mantisse == NULL )
	{
	 printf(" not enough memeory !!!\n") ;
	 destroyLii( &sqrt2 ) ;
	 destroyLii( &un ) ;
	 return 1 ;
	}

 printf("\n Formula used :\n") ;
 printf(" 1/sqrt(2) = 13860/19601/sqrt(1-1/384199201) \n\n") ;


 if (( base == 2 ) || ( base == 16 ))
	{
	 initialise_fixedPoint_bini( &sqrt2, 1 ) ;
	 initialise_fixedPoint_bini( &un, 1 ) ;
	 tops = times(NULL) ;

	 for ( k = 0 ; ; k++ )
		{
		 divHalfB_R_x86_64_bini( &un , 384199201 ) ;
		 if ( un.signe == 0 ) break ;
		 divHalfB_x86_64_bini( &aux , &un , 2*k+ 2 ) ;
		 sub_R_2P_x86_64_bini_spe( &un , &aux ) ;
		 add_R_2P_x86_64_bini_spe( &sqrt2 , &un ) ;
		}

	 tops2 = times(NULL) ;
	 printf(" Duration = %7.3f seconds.\n" , (tops2-tops)/ 100.0 ) ;
	 printf(" Number of iterations = %ld\n\n" , k ) ;

	 mulB_R_x86_64_bini( &sqrt2 , 13860 ) ;
	 divHalfB_R_x86_64_bini( &sqrt2 , 19601 ) ;
	 if ( base == 2 )  print_cst_base2_bini( &sqrt2 ) ;
		      else print_cst_base16_bini( &sqrt2 ) ;
	}


 destroyLii( &sqrt2 ) ;
 destroyLii( &un ) ;
 destroyLii( &aux ) ;
 return 0 ;
}



int calcul_e( long base, long Nb_decimales )
{
 long k ;
 Lii un ;
 Lii e ;
 long Nb_decimales_Base64 ;
 clock_t    tops , tops2 ;

 switch(base)
	{
	 case 16 : Nb_decimales_Base64 = ( Nb_decimales / 16 ) + 4 ;  break ;
	 case 2  : Nb_decimales_Base64 = ( Nb_decimales / 64 ) + 3 ; break ;
	 default : return 1 ;
	}

 // Cration des deux nombres.
 createLii( &e , Nb_decimales_Base64 ) ;
 if ( e.mantisse == NULL )
	{
	 printf(" not enough memeory !!!\n") ;
	 return 1 ;
	}
 createLii( &un    , Nb_decimales_Base64 ) ;
 if ( un.mantisse == NULL )
	{
	 printf(" not enough memeory !!!\n") ;
	 destroyLii( &e ) ;
	 return 1 ;
	}

 printf("\n Formula used :\n") ;
 printf(" e = 1/0! + 1/1! + 1/2! + ... \n\n") ;


 if (( base == 2 ) || ( base == 16 ))
	{
	 initialise_fixedPoint_bini( &e, 2 ) ;
	 initialise_fixedPoint_bini( &un, 1 ) ;
	 tops = times(NULL) ;

	 for ( k = 2 ; ; k++ )
		{
		 divHalfB_R_x86_64_bini( &un , k ) ;
		 if ( un.signe == 0 ) break ;
		 add_R_2P_x86_64_bini_spe( &e , &un ) ;
		}

	 tops2 = times(NULL) ;
	 printf(" Duration = %7.3f seconds.\n" , (tops2-tops)/ 100.0 ) ;
	 printf(" Number of iterations = %ld\n\n" , k ) ;

	 if ( base == 2 )  print_cst_base2_bini( &e ) ;
		      else print_cst_base16_bini( &e ) ;
	}


 destroyLii( &e ) ;
 destroyLii( &un ) ;
 return 0 ;
}


void printError(char* prog)
{
 printf("\n\n UTILISATION :  %s n cst radix [method]\n" , prog ) ;
 printf("    n      = number of digits\n") ;
 printf("    cst    = pi, e, sqrt2, 1/sqrt2\n") ;
 printf("    radix  = 2 or 16\n") ;
 printf("    method = 1, or 2, or 3, or 4 and only for pi with :\n") ;
 printf("      * 1  : pi/4 = arctan(1/2) + arctan(1/3)	(Newton)\n") ;
 printf("      * 2  : pi/4 = 4 arctan(1/5) - arctan(1/239)	(Machin)\n") ;
 printf("      * 3  : pi/4 = 12 arctan(1/18) + 8 arctan( 1/57 ) + 5 arctan( 1/239 )\n") ;
 printf("      * 4  : pi/4 = 17 arctan(1/23) + 8 arctan( 1/182 ) + 10 arctan( 1/5118 ) + 5 arctan( 1/6072 )\n\n") ;
}


int main( int argc , char * argv[] )
{

 long Nb_decimales ;
 long base ;
 int formule ;


 if (( argc < 4 ) || ( argc > 5))
	{
	 printError(argv[0]) ;
	 return 1 ;
	}

 Nb_decimales = atol( argv[1] ) ;

 if ( Nb_decimales <= 12 )
	{
	 printError(argv[0]) ;
	 return 1 ;
	}

 if (( strcmp(argv[2],"pi") != 0 ) && ( strcmp(argv[2],"e") != 0 ) && ( strcmp(argv[2],"sqrt2") != 0 ) &&
 	 ( strcmp(argv[2],"1/sqrt2") != 0 )
 )
	{
	 printError(argv[0]) ;
	 return 1 ;
	}

 base = atol( argv[3] ) ;

 if (( base != 2 ) && ( base != 16 ))
	{
	 printError(argv[0]) ;
	 return 1 ;
	}

 if (( strcmp(argv[2],"pi") == 0 ) && ( argc == 4 ))
	{
	 printError(argv[0]) ;
	 return 1 ;
	}

 if ( strcmp(argv[2],"pi") == 0 )
	{
	 formule = atoi( argv[4] ) ;
	 if (( formule < 1 ) || ( formule > 4 ))
		{
		 printError(argv[0]) ;
		 return 1 ;
		}
	 calcul_pi( base,Nb_decimales,formule ) ;
	 return 0 ;
	}

 if ( strcmp(argv[2],"sqrt2") == 0 )
	{
	 calcul_sqrt2( base,Nb_decimales ) ;
	 return 0 ;
	}

 if ( strcmp(argv[2],"e") == 0 )
	{
	 calcul_e( base,Nb_decimales ) ;
	 return 0 ;
	}

 if ( strcmp(argv[2],"1/sqrt2") == 0 )
	{
	 calcul_inv_sqrt2( base,Nb_decimales ) ;
	 return 0 ;
	}


 return 0 ;
}
