;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~        (C) Copyright raphi Software 2004 - All Rights Reserved      ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~ Author : Raphal PASQUIER                                           ~
;~ Email  : raphael.pasquier@neuf.fr                                   ~
;~ Version: 0.0.0.2                                                    ~
;~ Date   : 20/08/2005                                                 ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~                                                                     ~
;~    exemple d' utilisation de yasm et du C avec gcc sur GNU/linux    ~
;~                                                                     ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~                                                                     ~
;~  yasm -m amd64 -f elf software.asm -o software.o                    ~
;~                                                                     ~
;~  gcc -m64 software.o main.c -o main                                 ~
;~                                                                     ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~                                                                     ~
;~ Description : fait la somme de deux entiers longs positifs          ~
;~                                                                     ~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

BITS 64
	
GLOBAL sub_R_2P_x86_64_bini_spe

; en C => unsigned long int sub_R_2P_x86_64_bini_spe(Lii* a , Lii* b )
; opration : a <- a - b
; Je suppose que a >= b >= 0 . 
; registres utiliss :
; rax
; rcx
; rdx
; rsi
; rdi
; r8
; r9
; r11 


sub_R_2P_x86_64_bini_spe:

	mov rax, [rsi]  ; rcx = signe de b
	test rax, rax
	jnz l1
	ret

l1:
	xor r8,r8        ; carry = 0
	mov rcx, [rsi+32] ; rcx = b.indiceMax
	mov r10, rcx
	mov rdx, [rdi+16] ; rdi = &mantisse de a
	mov rsi, [rsi+16] ; rsi = &mantisse de b
	
boucle:
	xor rax, rax  ; rax = 0
	mov r9, [rdx]
	sub r9, [rsi]
	adc rax, 0
	sub r9, r8
	adc rax, 0
	mov [rdx], r9
	mov r8, rax
	add rsi,8
	add rdx,8
	dec rcx
	js l2  
	jmp boucle

l2:
	mov rcx, [rdi+32] ; rcx = a.indiceMax
	sub rcx, r10      ; rcx = a.indiceMax - b.indiceMax
	
boucle2:
	dec rcx
	js l3
	xor rax, rax
	sub [rdx], r8
	adc rax, 0
	mov r8, rax
	test r8, r8
	jz l3
	add rdx, 8
	jmp boucle2

l3:
	mov rcx, [rdi+32]
	shl rcx, 3
	mov rdx, [rdi+16] 
	
boucle3:
	mov r8, [rdx+rcx]
	test r8, r8
	jnz l4
	sub rcx, 8
	js l4
	jmp boucle3
	
l4:
	sar rcx, 3
	mov [rdi+32], rcx
	test rcx, rcx
	js l5
	ret
l5:
	xor r8, r8
	mov [rdi], r8
	ret			; retour  la routine appelante


